package com.googlecode.jpattern.gwt.client;

import java.util.HashMap;
import java.util.Map;

import com.googlecode.jpattern.gwt.client.logger.ILoggerService;
import com.googlecode.jpattern.gwt.client.logger.NullLoggerService;

/**
 * 
 * @author Francesco Cina'
 *
 * 12 Apr 2011
 */
public abstract class AApplication implements IApplicationProvider, IApplicationSystem {

	private ILoggerService loggerService = new NullLoggerService();
	private IServerCallService serverCallService = new NullServerCallService();
	private Map<String, IService> serviceMap = new HashMap<String, IService>();

	@Override
	public ILoggerService getLoggerService() {
		return loggerService;
	}
	
	@Override
	public void setLoggerService(ILoggerService loggerService) {
		if (loggerService!=null) {
			this.loggerService = loggerService;
		}
	}
	
	@Override
	public IServerCallService getServerCallService() {
		return serverCallService;
	}
	
	@Override
	public void setServerCallService(IServerCallService serverCallService) {
		if (serverCallService!=null) {
			this.serverCallService = serverCallService;
		}
	}
	
	@Override
	public IService getService(String serviceName) {
		if (serviceMap.containsKey(serviceName)) {
			return serviceMap.get(serviceName);
		}
		return new NullService();
	}
	
	@Override
	public void addService(String serviceName, IService service){
		serviceMap.put(serviceName, service);
	}

}
