package com.googlecode.jpattern.gwt.client;

import java.util.Map;

import com.googlecode.jpattern.gwt.client.communication.AProxy;
import com.googlecode.jpattern.gwt.client.communication.ICallbackAction;
import com.googlecode.jpattern.gwt.client.communication.NullProxy;
import com.googlecode.jpattern.gwt.shared.IWebResult;

/**
 * 
 * @author Francesco Cina'
 *
 * 06/mag/2011
 */
public class NullServerCallService implements IServerCallService {

	@Override
	public <T extends IWebResult> AProxy<T> get(Class<T> resultClass,
			ICallbackAction<T> callbackAction, String url,
			Map<String, String> keyValuesMap) {
		return new NullProxy<T>(callbackAction);
	}

	@Override
	public <T extends IWebResult> AProxy<T> delete(Class<T> resultClass,
			ICallbackAction<T> callbackAction, String url,
			Map<String, String> keyValuesMap) {
		return new NullProxy<T>(callbackAction);
	}

	@Override
	public <T extends IWebResult, Z> AProxy<T> post(Class<T> resultClass,
			Class<Z> dataClass, ICallbackAction<T> callbackAction, String url,
			Z data) {
		return new NullProxy<T>(callbackAction);
	}

	@Override
	public <T extends IWebResult, Z> AProxy<T> put(Class<T> resultClass,
			Class<Z> dataClass, ICallbackAction<T> callbackAction, String url,
			Z data) {
		return new NullProxy<T>(callbackAction);
	}


}
