package com.googlecode.jpattern.gwt.client.communication.rest;

import com.google.gwt.autobean.shared.AutoBean;
import com.google.gwt.autobean.shared.AutoBeanCodex;
import com.googlecode.jpattern.gwt.client.IBeanFactory;
import com.googlecode.jpattern.gwt.client.communication.rest.IObjectSerializer;

/**
 * 
 * @author Francesco Cina'
 *
 */
public class GenericsObjectSerializer<T> implements IObjectSerializer<T> {

	private final Class<T> aClass;
	
	public GenericsObjectSerializer(Class<T> aClass) {
		this.aClass = aClass;
	}

	@Override
	public T deserialize(IBeanFactory beanFactory, String json) {
		return AutoBeanCodex.decode(beanFactory, aClass, json).as();
	}

	@Override
	public String serialize(IBeanFactory beanFactory, T bean) {
		AutoBean<T> autoBean = beanFactory.create(aClass, bean);
		return AutoBeanCodex.encode(autoBean).getPayload();
	}

}
