package com.googlecode.jpattern.gwt.client.presenter;

import java.util.List;

import com.google.gwt.user.client.ui.HasWidgets;
import com.googlecode.jpattern.gwt.client.view.IView;
import com.googlecode.jpattern.shared.result.IErrorMessage;

/**
 * 
 * @author Francesco Cina'
 *
 * 14 Apr 2011
 */

public abstract class APresenter<T extends IView> implements IPresenter {
	
	private final T view;

	public APresenter(T view) {
		this.view = view;
		view.visit(this);
	}
	
	@Override
	public final void go(final HasWidgets container) {
		preDisplay();
		view.render(container);
	    postDisplay();
	}
	
	@Override
	public void onEventError(List<IErrorMessage> errorMessages) {
		view.getErrorArea().addErrorMessages(errorMessages);
	}
	
	public abstract void preDisplay();
	
	public abstract void postDisplay();

	
}
